#ifndef DEFINE_H
#define DEFINE_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <iostream.h>
#include <fstream.h>
#include <time.h>

static int ZMAX = 255;
static int ZMIN = 0;
static int ZMID = (ZMIN+ZMAX)/2;
static double LAMDA = (double)5.0;

static double maxarg1,maxarg2;
#define FMAX(a,b) (maxarg1=(a),maxarg2=(b),(maxarg1) > (maxarg2) ?\
        (maxarg1) : (maxarg2))

#define SIGN(a,b) ((b) >= 0.0 ? fabs(a) : -fabs(a))

static int iminarg1,iminarg2;
#define IMIN(a,b) (iminarg1=(a),iminarg2=(b),(iminarg1) < (iminarg2) ?\
        (iminarg1) : (iminarg2))

typedef struct BMP_HEADER{
   unsigned short int type;                 /* Magic identifier            */
   unsigned int size;                       /* File size in bytes          */
   unsigned short int reserved1, reserved2;
   unsigned int offset;                     /* Offset to image data, bytes */
}bmp_header;

typedef struct IRRADIANCE{
	double r;
	double g;
	double b;
}irradiance;

typedef struct BMP_INFOHEADER{
   unsigned int size;               /* Header size in bytes      */
   int width,height;                /* Width and height of image */
   unsigned short int planes;       /* Number of colour planes   */
   unsigned short int bits;         /* Bits per pixel            */
   unsigned int compression;        /* Compression type          */
   unsigned int imagesize;          /* Image size in bytes       */
   int xresolution, yresolution;    /* Pixels per meter          */
   unsigned int ncolours;           /* Number of colours         */
   unsigned int importantcolours;   /* Important colours         */
}bmp_infoheader;

typedef struct BMP{
	bmp_header			header;
	bmp_infoheader		info;
	unsigned char		*data;
}bmp;

typedef struct HDR{
	int xresolution;
	int yresolution;
	irradiance *s;
}hdr;

typedef struct CONFIG{
	int		frame_number;
	char	**image_name;
	double	*shutter;
	double	*lnt;	
}config;

config *load_config(char* filename);

void svd_build(double **a, int m, int n, double *w, double **v);
void svd_solve(double **u, double *w, double **v, int m, int n, double *b, double *x);

void bmp_read(char *filename, bmp *image);

void hdr_generate(bmp **b, config *conf, hdr *h, double *g[3]);
void hdr_write(char *filename, hdr *h);

#endif